﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.Net;
using System.IO;
using System.Data;
using ASPSnippets.GoogleAPI;
using System.Web.Script.Serialization;

public partial class CS2 : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        GoogleConnect.ClientId = " <Google Client ID>";
        GoogleConnect.ClientSecret = " <Google Client Secret>";

        GoogleConnect.RedirectUri = Request.Url.AbsoluteUri.Split('?')[0];
        GoogleConnect.API = EnumAPI.Contacts;
        if (!string.IsNullOrEmpty(Request.QueryString["code"]))
        {
            string code = Request.QueryString["code"];
            string json = GoogleConnect.Fetch("me", code, 10);
            GoogleContacts profile = new JavaScriptSerializer().Deserialize<GoogleContacts>(json);
            DataTable dt = new DataTable();
            dt.Columns.AddRange(new DataColumn[3] { new DataColumn("Name", typeof(string)),
                        new DataColumn("Email", typeof(string)),
                        new DataColumn("PhotoUrl",typeof(string)) });

            foreach (Contact contact in profile.Feed.Entry)
            {
                string name = contact.Title.T;
                string email = contact.GdEmail.Find(p => p.Primary).Address;
                Link photo = contact.Link.Find(p => p.Rel.EndsWith("#photo"));
                string photoUrl = GoogleConnect.GetPhotoUrl(photo != null ? photo.Href : "~/default.png", code);
                dt.Rows.Add(name, email, photoUrl);
                gvContacts.DataSource = dt;
                gvContacts.DataBind();
            }
            pnlProfile.Visible = true;
            btnLogin.Enabled = false;
        }
        if (Request.QueryString["error"] == "access_denied")
        {
            ClientScript.RegisterClientScriptBlock(this.GetType(), "alert", "alert('Access denied.')", true);
        }
    }

    protected void Login(object sender, EventArgs e)
    {
        GoogleConnect.Authorize(Server.UrlEncode("https://www.google.com/m8/feeds/"));
    }


    public class GoogleContacts
    {
        public Feed Feed { get; set; }
    }

    public class Feed
    {
        public GoogleTitle Title { get; set; }
        public List<Contact> Entry { get; set; }
    }

    public class GoogleTitle
    {
        public string T { get; set; }
    }

    public class Contact
    {
        public GoogleTitle Title { get; set; }
        public List<Email> GdEmail { get; set; }
        public List<Link> Link { get; set; }
    }
    public class Email
    {
        public string Address { get; set; }
        public bool Primary { get; set; }
    }

    public class Link
    {
        public string Rel { get; set; }
        public string Type { get; set; }
        public string Href { get; set; }
    }
}