﻿
Imports System.Data
Imports ASPSnippets.GoogleAPI
Imports System.Web.Script.Serialization

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        GoogleConnect.ClientId = " <Google Client ID>"
        GoogleConnect.ClientSecret = " <Google Client Secret>"

        GoogleConnect.RedirectUri = Request.Url.AbsoluteUri.Split("?"c)(0)
        GoogleConnect.API = EnumAPI.Contacts
        If Not String.IsNullOrEmpty(Request.QueryString("code")) Then
            Dim code As String = Request.QueryString("code")
            Dim json As String = GoogleConnect.Fetch("me", code, 10)
            Dim profile As GoogleContacts = New JavaScriptSerializer().Deserialize(Of GoogleContacts)(json)
            Dim dt As New DataTable()
            dt.Columns.AddRange(New DataColumn(2) {New DataColumn("Name", GetType(String)), New DataColumn("Email", GetType(String)), New DataColumn("PhotoUrl", GetType(String))})

            For Each contact As Contact In profile.Feed.Entry
                Dim name As String = contact.Title.T
                Dim email As String = contact.GdEmail.Find(Function(p) p.Primary).Address
                Dim photo As Link = contact.Link.Find(Function(p) p.Rel.EndsWith("#photo"))
                Dim photoUrl As String = GoogleConnect.GetPhotoUrl(If(photo IsNot Nothing, photo.Href, "~/default.png"), code)
                dt.Rows.Add(name, email, photoUrl)
                gvContacts.DataSource = dt
                gvContacts.DataBind()
            Next
            pnlProfile.Visible = True
            btnLogin.Enabled = False
        End If
        If Request.QueryString("error") = "access_denied" Then
            ClientScript.RegisterClientScriptBlock(Me.[GetType](), "alert", "alert('Access denied.')", True)
        End If
    End Sub

    Protected Sub Login(sender As Object, e As EventArgs)
        GoogleConnect.Authorize(Server.UrlEncode("https://www.google.com/m8/feeds/"))
    End Sub

    Public Class GoogleContacts
        Public Property Feed() As Feed
            Get
                Return m_Feed
            End Get
            Set(value As Feed)
                m_Feed = value
            End Set
        End Property
        Private m_Feed As Feed
    End Class

    Public Class Feed
        Public Property Title() As GoogleTitle
            Get
                Return m_Title
            End Get
            Set(value As GoogleTitle)
                m_Title = value
            End Set
        End Property
        Private m_Title As GoogleTitle
        Public Property Entry() As List(Of Contact)
            Get
                Return m_Entry
            End Get
            Set(value As List(Of Contact))
                m_Entry = value
            End Set
        End Property
        Private m_Entry As List(Of Contact)
    End Class

    Public Class GoogleTitle
        Public Property T() As String
            Get
                Return m_T
            End Get
            Set(value As String)
                m_T = value
            End Set
        End Property
        Private m_T As String
    End Class

    Public Class Contact
        Public Property Title() As GoogleTitle
            Get
                Return m_Title
            End Get
            Set(value As GoogleTitle)
                m_Title = value
            End Set
        End Property
        Private m_Title As GoogleTitle
        Public Property GdEmail() As List(Of Email)
            Get
                Return m_GdEmail
            End Get
            Set(value As List(Of Email))
                m_GdEmail = value
            End Set
        End Property
        Private m_GdEmail As List(Of Email)
        Public Property Link() As List(Of Link)
            Get
                Return m_Link
            End Get
            Set(value As List(Of Link))
                m_Link = value
            End Set
        End Property
        Private m_Link As List(Of Link)
    End Class

    Public Class Email
        Public Property Address() As String
            Get
                Return m_Address
            End Get
            Set(value As String)
                m_Address = value
            End Set
        End Property
        Private m_Address As String
        Public Property Primary() As Boolean
            Get
                Return m_Primary
            End Get
            Set(value As Boolean)
                m_Primary = value
            End Set
        End Property
        Private m_Primary As Boolean
    End Class

    Public Class Link
        Public Property Rel() As String
            Get
                Return m_Rel
            End Get
            Set(value As String)
                m_Rel = value
            End Set
        End Property
        Private m_Rel As String
        Public Property Type() As String
            Get
                Return m_Type
            End Get
            Set(value As String)
                m_Type = value
            End Set
        End Property
        Private m_Type As String
        Public Property Href() As String
            Get
                Return m_Href
            End Get
            Set(value As String)
                m_Href = value
            End Set
        End Property
        Private m_Href As String
    End Class
End Class
